import cr from './core';

class SystemMessage {
  public onFull: any;
  public onPage: any;

  constructor() {
    window.addEventListener('message', (e) => {
      this.accept(e.data);
    }, false);
  }

  post(t: any, r?: any) {
    window.parent.postMessage(t, r || '*');
  }

  accept(e: any) {
    // IE 不支持 Map
    // const evs = new Map([
    //   ['full-screen', this.onFull],
    //   ['page-load', this.onPage]
    // ]);
    // let action = evs.get(e.type) || this[e.type] || function() {};
    const evs = {
      'full-screen': this.onFull,
      'page-load': this.onPage
    };
    // @ts-ignore
    let action = evs[e.type] || this[e.type] || this.onMessage || cr.noop;
    action(e);
  }

  // 全屏
  emitFull(n: any) {
    this.post({type: 'full-screen', data: n});
  }

  // 页面高度
  emitPage(c: any) {
    let o = c;
    if (typeof c === 'string') {
      let m = document.querySelector(c);
      o = {
        // @ts-ignore
        width: m.offsetWidth, height: m.offsetHeight
      };
    } else if (typeof c === 'number') {
      o = {height: c};
    }
    this.post({type: 'page-load', data: o});
  }
}

export default SystemMessage;
